#!/usr/local/bin/perl -T

$| = 1; 
read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
@namevalues = split(/&/, $buffer);
foreach $namevalue (@namevalues) {
	($name, $value) = split(/=/, $namevalue);
	$name =~ tr/+/ /;
	$value =~ tr/+/ /;
	$name =~ s/%(..)/pack("C", hex($1))/eg;
	$value =~ s/%(..)/pack("C", hex($1))/eg;
	$value =~ s/<!--(.|\n)*-->//g; 
	$value =~ s/([:;<>\*\|`&\$!#\(\)\[\]\{\}'"])//g; 
	$form{$name} = $value;
}
if ($form{path}) {
	if (substr($form{'path'},0,1) eq '/') {$form{'path'} = substr($form{'path'},1)}
	if (substr($form{'path'},-1) ne '/') {$form{'path'} .= '/'}
}
$program = $ENV{SCRIPT_NAME};
$root = $ENV{DOCUMENT_ROOT};
if ($form{'directory'}) {
	$form{'access'}=qq~AuthUserFile $root/$form{'path'}.htpasswd
AuthGroupFile /dev/null
AuthName "$form{'directory'}"
AuthType Basic

<Limit GET POST>
require valid-user
</Limit>~;
	$form{'passwd'}="$form{'login'}:" . &Crypt($form{'password'});
}
&OutputPage;
sub OutputPage {
	print "Cache-Control: No-Cache\nContent-Type: text/html\n\n";
	print qq~<html><head><title>.htaccess Generator Tool</title><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"><style>h1 { font-weight:bold; color:#bbcd84; margin-top:0px; margin-bottom:0px; } input, textarea { cursor:text; color:#4f2d05; background:#bfb32f; margin:0px; padding:2px; border:1px solid #bbcd84; font-family:Verdana, Arial, sans-serif; font-size:medium; }</style></head><body style="margin:10px; color:#23bd00; background:#092701;">
	<form method=post action="$program">
	<table width="100%" cellpadding="3" cellspacing="6">
	<tr>
		<td colspan=2 align="center"><h1>.htaccess & .htpasswd Generator Tool</h1></td>
	</tr>
	<tr>
		<td width="319" align="right" valign="top"><strong>Name of the protected area:</strong></td>
		<td width="440" bgcolor="#495f41"><input name=directory value="$form{'directory'}" size="32"><br><font color="#ffffff"><small>Simply a reminder</small></font></td>
	</tr>
	<tr>
		<td align="right" valign="top"><strong>Name of the folder to protect</strong>:</td>
		<td bgcolor="#495f41"><input name=path value="$form{'path'}" size="32"><br><font color="#ffffff"><small>Path relative to the domain root, this folder will contain the generated files.<br>Do NOT forget to add a final slash &mdash; i.e. <strong>private/</strong></small></font></td>
	</tr>
	<tr>
		<td align="right"><strong>User</strong>:</td>
		<td bgcolor="#495f41"><input name=login value="$form{'login'}" size="32"></td>
	</tr>
	<tr>
		<td align="right"><strong>Password</strong>:</font></td>
		<td bgcolor="#495f41"><input type=password name=password value=$form{'password'} size="32"></td>
	</tr>
	<tr>
		<td></td><td><input value=" Go " type="submit" name="submit" style="color:#af630a; font-weight:bold; font-size:medium; cursor:pointer;"></td>
	</tr>
	<tr>
		<td colspan="2"><hr></td>
	</tr>
	<tr bgcolor="#495f41">
		<td valign="top"><font color="#ffffff">Code to copy and paste in the <strong>.htaccess</strong> file:</font></td>
		<td><textarea name=access cols=60 rows=10>$form{'access'}</textarea></td>
	</tr>
	<tr bgcolor="#495f41">
		<td valign="top"><font color="#ffffff">Code to copy and paste in the <strong>.htpasswd</strong> file:</font></td>
		<td><textarea name=passwd cols=60 rows=1>$form{'passwd'}</textarea></td>
	</tr>
</table>
</form></body></html>

~;
}
sub Crypt {
	my $pass_code = shift(@_);
	my @chr = ('a'..'z');
	my $s1= @chr[int(rand($#chr + 1))];
	my $s2= @chr[int(rand($#chr + 1))];
	my $salt = "$s1$s2";
	my $crypt=crypt($pass_code,$salt);
	return $crypt;
}